import java.util.*;

public class Second {


    public static void main(String[] args) {
        Scanner s =new Scanner(System.in);

        int employersCount = s.nextInt();
        int floorsCount = s.nextInt();

        ArrayList<Employer> employers = new ArrayList<>();

        for (int i = 0; i < employersCount; i++) {
            employers.add(new Employer(s.nextInt(), s.nextInt()));
        }

        Map<Integer, Integer> result = new HashMap<>();
        int floor = 1;
        int targetFloor = -1;
        int time = 0;
        boolean toDown = false;
        ArrayDeque<Integer> buffer = new ArrayDeque<>();

        while (employersCount > 0) {
            if (toDown) {
                if (floor == 1) {
                    Iterator<Integer> iterator = buffer.iterator();
                    while( iterator.hasNext()) {
                        int person = iterator.next();
                        result.put(person, time);
                        iterator.remove();
                        employersCount--;
                    }
                    toDown = false;
                } else {
                    floor--;
                    time++;
                    fetchEmployers(employers, floor, buffer, time);
                }
            } else {

                    while (targetFloor == -1 && employersCount > 0)
                    {
                        int minTime = Integer.MAX_VALUE;
                        for (Employer emp : employers) {
                            if (emp == null) {
                                continue;
                            }
                            if (emp.start < minTime && time >= emp.start) {
                                minTime = emp.start;
                                targetFloor = emp.floor;
                            }
                        }
                        if (targetFloor == -1) {
                            time++;
                        }
                    }

                if (targetFloor == floor) {
                    fetchEmployers(employers, floor, buffer, time);
                    toDown = true;
                    targetFloor = -1;
                } else  {
                    floor++;
                    time++;
                }
            }

        }
        for (Map.Entry<Integer, Integer> entry : result.entrySet()) {
            System.out.println(entry.getValue());
        }
    }

    private static void fetchEmployers(ArrayList<Employer> employers, int floor, ArrayDeque<Integer> buffer, int time) {
        for (int i = 0; i < employers.size(); i++) {
            Employer emp = employers.get(i);
            if (emp != null && emp.floor == floor && emp.start <= time) {
                buffer.add(i);
                employers.set(i, null);

            }
        }
    }

    private static class Employer {
        private final int start;
        private final int floor;


        public Employer(int start, int floor) {
            this.floor = floor;
            this.start = start;
        }
    }
}
